unit MessCARUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, RomUnit, ConfigUnit, Jpeg;

type
  TMessCAR = class(TForm)
    TimerCAR: TTimer;
    TimerDemarrage: TTimer;
    procedure TimerCARTimer(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TimerDemarrageTimer(Sender: TObject);
  private
    { Dclarations prives }
  public
    DateFermeture: TDateTime;
    Back: TBitmap;
    CallMainShow: TNotifyEvent;
    CallCARDone: TNotifyEvent;
    Texte: string;
    TexteFormat: string;
    MilliSec: integer;
    procedure DemarrerCAR;
    procedure ArreterCAR;
    procedure Dessiner;
  end;

var
  MessCAR: TMessCAR;

implementation

{$R *.dfm}

{ TMessCAR }

procedure TMessCAR.DemarrerCAR;
begin
  TimerDemarrage.Enabled := true;
end;

procedure TMessCAR.Dessiner;
var Front: TBitmap;
    H, i, n: integer;
    l: string;
begin
  Front := TBitmap.Create;
  Front.Width := Screen.Width;
  Front.Height := Screen.Height;

  // Fond
  Front.Canvas.Draw(0, 0, Back);

  // Texte
  with Front.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Assign(Config.FontDialog.Font);

    H := TextHeight('A');
    Sep := '|';
    n := nbmots(Texte);
    for i := 1 to n do
    begin
      l := mot(i, Texte);
      if l <> '' then
      begin
        if l[1] = '!' then
        begin
          l := copy(l, 2, length(l)-1);
          Font.Color := Config.ColorTable[MilliSec];
        end else Font.Color := Config.FontDialog.Font.Color;
        TextOut(Screen.Width div 2 - TextWidth(l) div 2,
                Screen.Height div 2 - n * H div 2 + (i - 1) * H,
                l);
      end;
    end;
    Sep := ' ';
  end;

  // Recopie
  Canvas.Draw(0, 0, Front);

  Front.Free;
end;

function myinttostr(int: integer): string;
begin
  result := StrLSized(inttostr(int), 2, '0');
end;

procedure TMessCAR.TimerCARTimer(Sender: TObject);
var Restant: TDateTime;
    d: string;
    b: boolean;
begin
  if now >= DateFermeture then
  begin
    // Si c'est fini ben on arrte
    CallCARDone(Self);
    ArreterCAR;
  end else begin
    // Sinon, mise  jour du texte d'affichage
    Restant := DateFermeture - now;
    d := '';
    b := false;
    if Restant >= 1 then
    begin
      d := d + ' ' + inttostr(trunc(restant)) + 'j';
      Restant := Restant - trunc(restant);
      b := true;
    end;
    Restant := Restant * 24;
    if (Restant >= 1) or b then
    begin
      d := d + ' ' + myinttostr(trunc(restant)) + 'h';
      Restant := Restant - trunc(restant);
      b := true;
    end;
    Restant := Restant * 60;
    if (Restant >= 1) or b then
    begin
      d := d + ' ' + myinttostr(trunc(restant)) + 'min';
      Restant := Restant - trunc(restant);
      b := true;
    end;
    Restant := Restant * 60;
    if (Restant >= 1) or b then
    begin
      d := d + ' ' + myinttostr(trunc(restant)) + 's';
      Restant := Restant - trunc(restant);
    end;
    Restant := Restant * 100;
    MilliSec := trunc(restant);
    d := d + ' ' + myinttostr(trunc(restant)) + 'ms';
    d := Trim(d);
    Texte := Remplace(TexteFormat, '$d', d);

    // Rafraichissement de l'image
    Dessiner;
  end;
end;

procedure TMessCAR.FormPaint(Sender: TObject);
begin
  Dessiner;
end;

procedure TMessCAR.ArreterCAR;
begin
  Back.Free;
  TimerCAR.Enabled := false;
  Hide;
  CallMainShow(Self);
end;

procedure TMessCAR.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = 27 then ArreterCAR;
end;

procedure TMessCAR.TimerDemarrageTimer(Sender: TObject);
var C: TCanvas;
    Img: TImage;
begin
  Back := TBitmap.Create;
  Back.Width := Screen.Width;
  Back.Height := Screen.Height;

  // Rcupration de l'image de fond
  if Config.PseudoTransparence.Checked then
  begin
    C := TCanvas.Create;
    C.Handle := GetWindowDC(GetDesktopWindow);
    Back.Canvas.CopyRect(Rect(0, 0, Back.Width, Back.Height), C, Rect(0, 0, Back.Width, Back.Height));
    C.Free;
  end else
  if Config.Couleur.Checked then
  begin
    with Back.Canvas do
    begin
      Brush.Color := Config.PanelCouleur.Color;
      Brush.Style := bsSolid;
      FillRect(Rect(0, 0, Back.Width, Back.Height));
    end;
  end else
  if Config.Image.Checked then
  begin
    with Back.Canvas do
    begin
      Brush.Color := Config.PanelCouleur.Color;
      Brush.Style := bsSolid;
      FillRect(Rect(0, 0, Back.Width, Back.Height));
    end;
    Img := TImage.Create(nil);
    Img.Picture.LoadFromFile(Config.ImagePath.Text);
    if Config.ImageCentree.Checked then
    begin
      Back.Canvas.Draw(Back.Width div 2 - Img.Picture.Width div 2, Back.Height div 2 - Img.Picture.Height div 2, Img.Picture.Graphic);
    end else begin
      Back.Canvas.Draw(0, 0, Img.Picture.Graphic);
    end;
    Img.Free;
  end;

  Config.MajColorTable;
  if Config.ShowCursor.Checked then Cursor := crDefault else Cursor := crNone;

  Show;
  TimerDemarrage.Enabled := false;
  TimerCAR.Enabled := true;
end;

end.
