(*
MIDI unit
by DooMeeR (webmaster@doomeer.com)

This unit contains the functions I use the most. Almost all of these have
been developped by me, since I started programming with Delphi, so some of them
aren't optimized at all.

Warning: This file is updated quite often, but no version number is saved, so
you might find another version of it someday...
*)
unit RomUnit;

interface

uses Windows, Classes, Graphics, Dialogs, SysUtils, {FileCtrl,} Forms, Controls,
     Registry, ShellAPI;

{$WRITEABLECONST ON}
const TailleSecteur=65536;

type TSecteur=array[1..TailleSecteur] of Byte;    // Un bloc de fichier
     TSecteurClass=class                          // Idem mais utilisable par un TList
       Secteur: TSecteur;
       constructor Create(FSecteur: TSecteur);
     end;
     TFichier=class
       Nom: string;                               // Nom du fichier
       Contenu: TList;                            // Contenu du fichier dans la mmoire
       Size: integer;                             // Taille du fichier
       PosIn: integer;                              // Position actuelle dans le fichier

       function Name: string;                     // Rcupre le NOM.EXT
       function Ext: string;                      // Rcupre le EXT
       function Path: string;                     // Rcupre le PATH
       function NameNoExt: string;                // Rcupre le NOM

       constructor Create(FNom: string);          // Crer, com d'hab  utiliser au dbut
       procedure Open;                            // Mettre en mmoire le fichier NOM
       procedure Save;                            // Sauver le fichier en mmoire dans NOM
       procedure Vider;                           // Librer la mmoire

       function Read: byte;                       // Lit l'octet POSIN, et incrmente de 1 POSIN (si pas atend)
       procedure Write(Ch: byte);                 // Ecrit sur l'octet POSIN, et incrmente de 1 POSIN
                                                  // (peut modifier Contenu.Count et Size en consquence)

       function ReadAt(Oc: integer): byte;        // Lit l'octet Oc
       procedure WriteAt(Oc: integer; Ch: byte);  // Ecrit Ch  Oc

       function AtEnd: boolean;                   // Pos>Size?

       function ReadBool: boolean;
       function ReadInteger: integer;
       function ReadStr(cnt: integer): string;
       function ReadAutoStr: string;

       procedure WriteBool(bool: boolean);
       procedure WriteInteger(int: integer);
       procedure WriteStr(str: string);
       procedure WriteAutoStr(str: string);
     end;
     FileByte = file of byte; // Type requis pour les fonction FRead... et FWrite... .
     TExtFileStream = class(TFileStream)
       procedure WriteByte(by: byte);
       procedure WriteChar(ch: char);
       procedure WriteBool(bool: boolean);
       procedure WriteWord(int: word);
       procedure WriteInteger(int: integer);
       procedure WriteCardinal(int: cardinal);
       procedure WriteStr(str: string);
       procedure WriteStrWOSize(str: string);
       function ReadByte: byte;
       function ReadChar: char;
       function ReadBool: boolean;
       function ReadInteger: integer;
       function ReadStr: string;
     end;
     TExtMemoryStream = class(TMemoryStream)
       // Ecriture
       procedure WriteByte(by: byte);
       procedure WriteChar(ch: char);
       procedure WriteBool(bool: boolean);
       procedure WriteWord(int: word);
       procedure WriteInteger(int: integer);
       procedure WriteCardinal(int: cardinal);
       procedure WriteStr(str: string);
       procedure WriteStrWOSize(str: string);
       procedure WriteDouble(d: double);

       // Lecture par procedure
       procedure ReadByte(var by: byte); overload;
       procedure ReadChar(var ch: char); overload;
       procedure ReadBool(var bool: boolean); overload;
       procedure ReadWord(var int: word); overload;
       procedure ReadInteger(var int: integer); overload;
       procedure ReadCardinal(var int: cardinal); overload;
       procedure ReadStr(var str: string); overload;
       procedure ReadStrWOSize(var str: string; Size: integer); overload;
       procedure ReadDouble(var d: double); overload;

       // Lecture par fonction
       function ReadByte: byte; overload;
       function ReadChar: char; overload;
       function ReadBool: boolean; overload;
       function ReadInteger: integer; overload;
       function ReadCardinal: cardinal; overload;
       function ReadStr: string; overload;
       function ReadDouble: double; overload;
       function ReadStrWOSize(Size: integer): string; overload;
     end;

function NbMots(phrase: string): integer; // Rcupre le nombre de mots
function Mot(num: integer; phrase: string): string; // Rcupre le mot num
function MotPos(sub, phrase: string; casematters: boolean): integer; // Indice du mot sub dans phrase
function Cut(phrase: string; deb, fin: integer): string; // Copy en non-relatif
function Min(phrase: string): string; // Suppression des sparations avant/aprs
function Remplace(dans, quoi, par: string): string; // Remplacement dans une chaine
function HexToInt(Hex: string): integer; // Remplace un hxadcimal en un dcimal
function UpStr(phrase: string): string; // UpCase pour toutes les lettres
function droite(substr: string; s: string): string; // rcuprer la partie droite d'un string
function gauche(substr: string; s: string): string; // rcuprer la partie gauche d'un string

function ColorRGB(R, G, B: byte): TColor; // Couleur en dfinissant ROUGE VERT BLEU
function ColAdd(Col: TColor; PR, PG, PB: integer): TColor;
                                          // Ajouter ROUGE VERT BLEU  une couleur
function ColInverse(Col: TColor): TColor; // Ngatif
function ColMix(Col1: TColor; Col2: TColor): TColor; // Mixage de 2 couleurs
function Red(Col: TColor): byte;   // Valeur rouge d'une couleur
function Green(Col: TColor): byte; // Valeur vert d'une couleur
function Blue(Col: TColor): byte;  // Valeur bleu d'une couleur

function FileCopy(source: string; cible: string; AnnuleSiExiste: Boolean): boolean; // Copie de fichier
function FileRename(AncienNom: string; NouvNom: string): boolean; // Renommer un fichier

procedure CreerRep(nom: string); // Cre le rpertoire nom

function FReadByte   (var Fic: FileByte): byte; // Ds 1 filebyte: lire un byte (1 oct)
function FReadBool   (var Fic: FileByte): boolean; // Ds 1 filebyte: lire un boolean (1 oct)
function FReadInteger(var Fic: FileByte): integer; // Ds 1 filebyte: lire un integer (4 oct)
function FReadStr    (var Fic: FileByte; Len: byte): string; // Ds 1 filebyte: lire un string
function FReadAutoStr(var Fic: FileByte): string; // Ds 1 filebyte: lire un string (en lisant auto la taille)
procedure FWriteByte   (var Fic: FileByte; Value: byte); // Ds 1 filebyte: crire un byte
procedure FWriteBool   (var Fic: FileByte; Value: boolean); // Ds 1 filebyte: crire un boolean
procedure FWriteInteger(var Fic: FileByte; Value: integer); // Ds 1 filebyte: crire un integer
procedure FWriteStr    (var Fic: FileByte; Value: string); // Ds 1 filebyte: crire un string
procedure FWriteAutoStr(var Fic: FileByte; Value: string); // Ds 1 filebyte: crire un string (en crivant la taille)

function GetVar(varname: string): string; // Pour rcuprer le contenu d'une variable d'environnement

function GetParams: string; // Pour rcuprer, dans une appli CGI, la liste des paramtres.
                            // Attention la mthode POST a priorit sur la mthode GET (pas droit aux deux!)
function GetParVal(params, par: string): string; // Pour rcuprer le contenu d'un des paramtres (appli CGI)
function GetTextArea(params, par: string): TStringList; // Pour rcuprer un <TEXTAREA>
// Note: pour les deux procdures ci-dessus il ne faut pas envoyer le texte avec FormDecode pour qu'elles fonctionnent
// correctement. Vous pouvez utiliser FormDecode aprs GetParVal, mais GetTextArea renvoie le texte dj dcod.
procedure Send(str: string); // Envoi d'une ligne qui ira  la suite du document HTML (CGI)
procedure TextInit; // Cration d'un en-tte pour un CGI de type texte -  crire au tout dbut
function FormDecode(str: string): string; // transforme les + et les %AA dans un texte de formulaire HTML
function ToHTML(str: string): string; // transforme un string avec %0D%0A en <BR>
function FormToHTML(str: string): string; // combine FormDecode et ToHTML

procedure delay(delai: double; var Appli: TApplication); // Comme dans Turbo Pascal: on attend pendant <delai> millisecondes

function DaysIn(d: tdate): integer; // Nombre de jours dans la date d, en partant de JC :))
function DayOf(d: tdate): string;   // n du jour dans le mois
function MonthOf(d: tdate): string; // EN TOUTES LETTRES!!!!!! (le mois)
function NumMonthOf(d: tdate): string; // EN CHIFFRE!!!!!! (le mois)
function MonthOfNum(num: integer): string;
function YearOf(d: tdate): string;  // anne en QUATRE chiffres
function HourOf(t: TDateTime): string;                 // Heures en 2 chiffres
function MinOf(t: TDateTime): string;                  // Minutes en 2 chiffres
function SecOf(t: TDateTime): string;                  // Secondes en 2 chiffres

function GetExeAll: string;  // Path + Nom du fichier excutable
function GetExePath: string; // Path avec \ du fichier excutable
function GetExeName: string; // Nom sans path du fichier excutable
function GetExeShortName: string; // Nom sans path ni ext du fichier excutable

function WMatch(wild, all: string): boolean; // WildCard Match

function Puissance(Nb, P: integer): integer; // Nb^P

function Rounded(N: real; R: integer): integer; // Arrondir  R

procedure Debug(Txt: array of const);
procedure ClearDebug;
var BeginTimeCountVar, EndTimeCountVar: cardinal;
procedure DebugBeginTC;
procedure DebugEndTC;
function DebugTC: cardinal;

function B4ToInt(B1, B2, B3, B4: byte): integer; // Transforme 4 bytes en un integer (bytes inverss!)
function IntToB1(int: integer): byte; // Rcupre 1er byte d'un integer (bytes inverss!)
function IntToB2(int: integer): byte; // Rcupre 2e byte d'un integer (bytes inverss!)
function IntToB3(int: integer): byte; // Rcupre 3e byte d'un integer (bytes inverss!)
function IntToB4(int: integer): byte; // Rcupre 4e byte d'un integer (bytes inverss!)

// Fonctions de gestion d'heures et dates qui marchent mieux que MonthOf etc
function GetDay(When: TDateTime): string;
function GetMonth(When: TDateTime): string;
function GetYear(When: TDateTime): string;
function GetAllHour(When: TDateTime): string; // Heure, depuis le 0.0
function GetHour(When: TDateTime): string;
function GetMin(When: TDateTime): string;
function GetSec(When: TDateTime): string;

function GetNDay(When: TDateTime): integer;
function GetNMonth(When: TDateTime): integer;
function GetNYear(When: TDateTime): integer;
function GetNHour(When: TDateTime): integer;
function GetNMin(When: TDateTime): integer;
function GetNSec(When: TDateTime): integer;

function AddTime(When: TDateTime; Hour, Min, Sec: integer): TDateTime; overload;
function AddTime(When: TDateTime; Hour: integer): TDateTime; overload;
function AddDays(When: TDateTime; Days: integer): TDateTime;

function BTSTF(b: boolean): string;

function StrLSized(s: string; size: integer; AddCharToLeft: char): string;
function StrRSized(s: string; size: integer; AddCharToRight: char): string;

function IntToFileSize(i: integer): string;

function WinDir: string; // Renvoie le rep de windows avec \

function ExpPars(s: string; gui, spc: char): TStringList; overload;
function ExpPars(s: string): TStringList; overload;

function booltostr(b: boolean; t, f: string): string; overload; // Boolean to string
function booltostr(b: boolean): string; overload; // Boolean to string
function strtobool(s: string; t, f: string): boolean; overload; // String to boolean, t et f dfinis
function strtobool(s: string): boolean; overload; // String to boolean, t et f de +r types

function bit(bitnum, int: cardinal): boolean;

function ExtPos(sub, s: string; n: integer): integer; // Donne la position du nime sub dans s
function ExtDroite(sub, s: string; n: integer): string; // Donne la drotie du nime sub dans s
function ExtGauche(sub, s: string; n: integer): string; // Donne la gauche du nime sub dans s
function SubCount(sub, s: string): integer; // Compte le nombre de sub dans s
procedure MakeDir(dir: string); // Cre un rpertoire. Utilisable avec ExtractFilePath

function IntPower(Base: Extended; Exponent: Integer): Extended;
function Power(Base, Exponent: Extended): Extended; // Eleve base  la puissance exponent

function PointInRect(X, Y: integer; XR, YR, W, H: integer): boolean; // Teste si un point est dans un rectangle de centre XR, YR et de taille W, H

function StrIsInt(S: string): boolean;

// Recherche de fichiers
// filter: filtre (par exemple, c:\*.*)
// Folders: renvoie aussi les dossiers
// SubFolders: nombre d'itrations pour les sous-dossiers
// (0 = pas de recherche dans les sous-dossiers, 1 = recherche dans chaque sous-dossiers
// des dossiers trouvs, 2 = recherche dans tous les sous-sous-dossiers...)
// (Entrez -1 pour l'infini)
function FileSearch(path, filter: string; Folders: boolean; SubFolders: integer): TStringList; overload;
// idem, sauf que a ajoute  la fin d'un TStringList existant
// AddIfExists: true: ajoute mme si existe dj; false: ignore si existe dj
procedure FileSearch(path, filter: string; Folders: boolean; SubFolders: integer; AddTo: TStringList; AddIfExists: boolean); overload;

// ajoute e  la fin de str si e n'y est pas dj
function StrEnded(str, e: string): string;
// idem mais pour un char (plus rapide)
function StrEndedC(str: string; e: char): string;

function RegExtractAssociatedIcon(Ext: string; small: boolean): HICON;

function MyGetTickCount: cardinal;

//procedure Debug(var

const Sep: char=' '; // La sparation entre deux mots
      EOL=chr($0D)+chr($0A); // Fin de ligne;
      CRLF=EOL;

implementation

(******************************************************************************)
// TFICHIER

function TFichier.ReadBool: boolean;
var c1: byte;
begin
  if not AtEnd then
  begin
    c1:=read;
  end else c1:=0;
  result:=(c1=1);
end;

function TFichier.ReadInteger: integer;
var c1, c2, c3, c4: byte;
begin
  if not AtEnd then
  begin
    c1:=read;
  end else c1:=0;
  if not AtEnd then
  begin
    c2:=read;
  end else c2:=0;
  if not AtEnd then
  begin
    c3:=read;
  end else c3:=0;
  if not AtEnd then
  begin
    c4:=read;
  end else c4:=0;
  result:=StrToInt('$'+IntToHex(c4, 2)+IntToHex(c3, 2)+IntToHex(c2, 2)+IntToHex(c1, 2));
end;

function TFichier.ReadStr(cnt: integer): string;
var i: integer;
    b: byte;
begin
  result:='';
  for i:=1 to cnt do
  begin
    if not AtEnd then
    begin
      b:=read;
    end else b:=0;
    result:=result+chr(b);
  end;
end;

function TFichier.ReadAutoStr: string;
var i: integer;
    b: byte;
    Len: integer;
begin
  result:='';
  if not AtEnd then
  begin
    Len:=ReadInteger;
  end else Len:=0;

  if Len>0 then
    for i:=1 to Len do
    begin
      if not AtEnd then
      begin
        b:=read;
      end else b:=0;
      result:=result+chr(b);
    end;
end;

procedure TFichier.WriteBool(bool: boolean);
var i: byte;
begin
  if bool then i:=1 else i:=0;
  write(i);
end;

procedure TFichier.WriteInteger(int: integer);
var c1, c2, c3, c4: byte;
    hex: string;
begin
  hex:=IntToHex(int, 8);
  c1:=StrToInt('$'+hex[7]+hex[8]);
  c2:=StrToInt('$'+hex[5]+hex[6]);
  c3:=StrToInt('$'+hex[3]+hex[4]);
  c4:=StrToInt('$'+hex[1]+hex[2]);
  write(c1);
  write(c2);
  write(c3);
  write(c4);
end;

procedure TFichier.WriteStr(str: string);
var i: integer;
    c: byte;
begin
  for i:=1 to length(str) do
  begin
    c:=ord(str[i]);
    write(c);
  end;
end;

procedure TFichier.WriteAutoStr(str: string);
var i: integer;
    c: byte;
begin
  WriteInteger(length(str));
  for i:=1 to length(str) do
  begin
    c:=ord(str[i]);
    write(c);
  end;
end;

function TFichier.Name: string;
begin
  result:=ExtractFileName(Nom);
end;

function TFichier.Ext: string;
begin
  result:=copy(ExtractFileExt(Nom), 2, 3);
end;

function TFichier.Path: string;
begin
  result:=extractfilepath(nom);
  if result[length(result)]='\' then result:=copy(result, 1, length(result)-1);
end;

function TFichier.NameNoExt: string;
begin
  result:=copy(name, 1, pos('.', name)-1);
end;

constructor TFichier.Create(FNom: string);
begin
  Nom:=FNom;
  Contenu:=TList.Create;
  Posin:=1;
  Size:=0;
end;

procedure TFichier.Open;
var Fic: file;
    ASecteur: TSecteur;
    NumRead: integer;
begin
  Vider;
  if fileexists(Nom) then
  begin
    assignfile(Fic, Nom);
    reset(Fic, 1);

    Size:=0;
    NumRead:=TailleSecteur;
    while NumRead=TailleSecteur do
    begin
      BlockRead(Fic, ASecteur, TailleSecteur, NumRead);
      Contenu.Add(TSecteurClass.Create(ASecteur));
      Size:=Size+NumRead;
    end;

    closefile(Fic);
  end;
  Posin:=1;
end;

procedure TFichier.Save;
var Fic: file;
    ASecteurClass: TSecteurClass;
    NumWritten: integer;
    i: integer;
    AncienSize: integer;
begin
  assignfile(Fic, Nom);
  rewrite(Fic, 1);

  AncienSize:=Size;

  if Contenu.Count>1 then
  begin
    for i:=0 to Contenu.Count-2 do
    begin
      ASecteurClass:=Contenu[i];
      BlockWrite(Fic, ASecteurClass.Secteur, TailleSecteur, NumWritten);
      Size:=Size-TailleSecteur;
    end;
  end;

  ASecteurClass:=Contenu[Contenu.Count-1];
  BlockWrite(Fic, ASecteurClass.Secteur, Size, NumWritten);

  Size:=AncienSize;

  closefile(Fic);
end;

procedure TFichier.Vider;
var i: integer;
    ASecteurClass: TSecteurClass;
begin
  for i:=contenu.count-1 downto 0 do
  begin
    ASecteurClass:=contenu[i];
    ASecteurClass.Free;
    Contenu.Delete(i);
  end;
  Posin:=1;
  Size:=0;
end;

function TFichier.Read: byte;
begin
  if not AtEnd then
  begin
    result:=ReadAt(posin);
    posin:=posin+1;
  end else result:=0;
end;

procedure TFichier.Write(Ch: byte);
var ASecteurClass: TSecteurClass;
    ASecteur: TSecteur;
    i: integer;
begin
  if not AtEnd then
  begin
    WriteAt(posin, ch);
  end else begin
    i:=size;
    while i>=TailleSecteur do
      i:=i-TailleSecteur;

    if i=0 then
    begin
      ASecteur[1]:=Ch;
      ASecteurClass:=TSecteurClass.Create(ASecteur);
      Contenu.Add(ASecteurClass);
    end else begin
      ASecteurClass:=Contenu[Contenu.Count-1];
      ASecteurClass.Secteur[i+1]:=Ch;
    end;

    Size:=Size+1;
  end;
  posin:=posin+1;
end;

function TFichier.ReadAt(Oc: integer): byte;
var ASecteurClass: TSecteurClass;
    i, n: integer;
begin
  if Oc<=Size then
  begin
    i:=0;
    n:=Oc;
    while n>TailleSecteur do
    begin
      n:=n-TailleSecteur;
      i:=i+1;
    end;
    ASecteurClass:=Contenu[i];
    result:=ASecteurClass.Secteur[n];
  end else result:=0;
end;

procedure TFichier.WriteAt(Oc: integer; Ch: byte);
var ASecteurClass: TSecteurClass;
    i, n: integer;
begin
  if Oc<=Size then
  begin
    i:=0;
    n:=Oc;
    while n>=TailleSecteur do
    begin
      n:=n-TailleSecteur;
      i:=i+1;
    end;
    ASecteurClass:=Contenu[i];
    ASecteurClass.Secteur[n]:=Ch;
  end else Write(Ch);
end;

function TFichier.AtEnd: boolean;
begin
  result:=(posin>size);
end;

constructor TSecteurClass.Create(FSecteur: TSecteur);
begin
  Secteur:=FSecteur;
end;

(******************************************************************************)

function NbMots(phrase: string): integer;
var tamp: string;
    i: integer;
begin
  tamp:=min(phrase);
  i:=0;
  while length(tamp)>0 do
  begin
    if Pos(Sep, tamp)<>0 then
    begin
      tamp:=cut(tamp, pos(Sep, tamp)+1, length(tamp));
      tamp:=min(tamp);
    end else tamp:='';
    i:=i+1;
  end;
  result:=i;
end;

function Mot(num: integer; phrase: string): string;
var i: integer;
    tamp: string;
begin
  if (num<=NbMots(phrase)) and (num>0) then
  begin
    tamp:=min(phrase);
    i:=0;
    while i<num-1 do
    begin
      if Pos(Sep, tamp)<>0 then
      begin
        tamp:=cut(tamp, pos(Sep, tamp)+1, length(tamp));
        tamp:=min(tamp);
      end else tamp:='';
      i:=i+1;
    end;
    tamp:=tamp+Sep;
    result:=cut(tamp, 1, pos(Sep, tamp));
    result:=min(result);
  end else result:='';
end;

function MotPos(sub, phrase: string; casematters: boolean): integer;
var i: integer;
begin
  if not casematters then
  begin
    sub:=uppercase(sub);
    phrase:=uppercase(phrase);
  end;
  sub:=min(sub);

  result:=0;
  for i:=1 to nbmots(phrase) do if mot(i, phrase)=sub then
  begin
    result:=i;
    break;
  end;
end;

function Cut(phrase: string; deb, fin: integer): string;
begin
  if (deb>0) and
     (deb<=length(phrase)) and
     (fin<=length(phrase)) and
     (length(phrase)>0) then
    result:=Copy(phrase, deb, fin-deb+1)
  else
    result:='';
end;

function Min(phrase: string): string;
var tamp: string;
    doit: boolean;
    i: integer;
begin
  result:=phrase;
  if length(phrase)>1 then
  begin
    tamp:=phrase;
    while tamp[1]=Sep do if length(tamp)>1 then tamp:=cut(tamp, 2, length(tamp)) else break;
    while tamp[length(tamp)]=Sep do if length(tamp)>1 then tamp:=cut(tamp, 1, length(tamp)-1) else break;
    result:=tamp;
  end;
  doit:=true;
  for i:=1 to length(phrase) do
    if phrase[i]<>sep then doit:=false;
  if doit then result:='';
end;

function Remplace(dans, quoi, par: string): string;
var tamp: string;
begin
  tamp:=dans;
  while pos(quoi, tamp)<>0 do
    tamp:=cut(tamp, 1, pos(quoi, tamp)-1)+
          par+
          cut(tamp, pos(quoi, tamp)+length(quoi), length(tamp));
  result:=tamp;
end;

function HexToInt(Hex: string): integer;
begin
  result:=StrToInt('$'+Hex);
end;

function UpStr(phrase: string): string;
var tamp: string;
    i: integer;
begin
  tamp:=phrase;
  for i:=1 to length(phrase) do
    tamp[i]:=UpCase(tamp[i]);
  result:=tamp;
end;

function droite(substr: string; s: string): string;
begin
  result:=copy(s, pos(substr, s)+length(substr), length(s)-pos(substr, s)+length(substr));
end;

function gauche(substr: string; s: string): string;
begin
  result:=copy(s, 1, pos(substr, s)-1);
end;

function ColorRGB(R, G, B: byte): TColor;
begin
  result:=strtoint('$00'+inttohex(B, 2)+inttohex(G, 2)+inttohex(R, 2));
end;

function ColAdd(Col: TColor; PR, PG, PB: integer): TColor;
var R, G, B: byte;
begin
  R:=Red(Col);
  G:=Green(Col);
  B:=Blue(Col);
  if R+PR>255 then R:=255 else
  if R+PR<0   then R:=0   else
    R:=R+PR;
  if G+PG>255 then G:=255 else
  if G+PG<0   then G:=0   else
    G:=G+PG;
  if B+PB>255 then B:=255 else
  if B+PB<0   then B:=0   else
    B:=B+PB;
  result:=StrToInt('$00'+IntToHex(B, 2)+IntToHex(G, 2)+IntToHex(R, 2));
end;

function ColInverse(Col: TColor): TColor;
var R, G, B: byte;
begin
  R:=255-StrToInt('$'+copy(IntToHex(Col, 6), 5, 2));
  G:=255-StrToInt('$'+copy(IntToHex(Col, 6), 3, 2));
  B:=255-StrToInt('$'+copy(IntToHex(Col, 6), 1, 2));
  result:=StrToInt('$00'+IntToHex(B, 2)+IntToHex(G, 2)+IntToHex(R, 2));
end;

function ColMix(Col1: TColor; Col2: TColor): TColor;
var R1, G1, B1: byte;
    R2, G2, B2: byte;
    R, G, B: byte;
begin
  R1:=Red(Col1);
  G1:=Green(Col1);
  B1:=Blue(Col1);
  R2:=Red(Col2);
  G2:=Green(Col2);
  B2:=Blue(Col2);
  R:=((R1+R2) div 2);
  G:=((G1+G2) div 2);
  B:=((B1+B2) div 2);
  result:=StrToInt('$00'+IntToHex(B, 2)+IntToHex(G, 2)+IntToHex(R, 2));
end;

function Red(Col: TColor): byte;
begin
  result:=StrToInt('$'+copy(IntToHex(Col, 6), 5, 2));
end;

function Green(Col: TColor): byte;
begin
  result:=StrToInt('$'+copy(IntToHex(Col, 6), 3, 2));
end;

function Blue(Col: TColor): byte;
begin
  result:=StrToInt('$'+copy(IntToHex(Col, 6), 1, 2));
end;

function FileCopy(source: string; cible: string; AnnuleSiExiste: Boolean): boolean;
{------------------------------------------------------------------------------}
{copie le fichier source vers le fichier cible. si le fichier cible existe dj}
{ la copie ne se fait que si AnnuleSiFichier est  true                        }
{------------------------------------------------------------------------------}
var NomSource, NomCible: array[0..255] of Char;
begin
  StrPCopy(NomSource, Source);
  StrPCopy(NomCible, Cible);
  result:=CopyFile(NomSource, NomCible, AnnuleSiExiste);
end;

function FileRename(AncienNom: string; NouvNom: string): boolean;
{----------------------------------------------------------------------------------------}
{ Renomme le fichier portant le nom AncienNom en lui donnant le nom contenu dans NouvNom }
{----------------------------------------------------------------------------------------}
var Ancien, Nouveau: array[0..255] of Char;
begin
  StrPCopy(Ancien, AncienNom);
  StrPCopy(Nouveau, NouvNom);
  result:=MoveFile(Ancien, Nouveau);
end;

procedure CreerRep(nom: string);
var PCharNom: array[0..255] of Char;
begin
  StrPCopy(PCharNom, nom);
  if not directoryexists(PCharNom) then
    if not createdirectory(PCharNom, nil) then
      raise Exception.Create('Impossible de crer le rpertoire '+nom+'!');
end;

function FReadByte(var Fic: FileByte): byte;
var c1: byte;
begin
  if not eof(Fic) then
  begin
    read(Fic, c1);
  end else c1:=0;
  result:=c1;
end;

function FReadBool(var Fic: FileByte): boolean;
var c1: byte;
begin
  if not eof(Fic) then
  begin
    read(Fic, c1);
  end else c1:=0;
  result:=c1=1;
end;

function FReadInteger(var Fic: FileByte): integer;
var c1, c2, c3, c4: byte;
begin
  if not eof(Fic) then
  begin
  read(Fic, c1);
  end else c1:=0;
  if not eof(Fic) then
  begin
  read(Fic, c2);
  end else c2:=0;
  if not eof(Fic) then
  begin
  read(Fic, c3);
  end else c3:=0;
  if not eof(Fic) then
  begin
  read(Fic, c4);
  end else c4:=0;
  result:=StrToInt('$'+IntToHex(c4, 2)+IntToHex(c3, 2)+IntToHex(c2, 2)+IntToHex(c1, 2));
end;

function FReadStr(var Fic: FileByte; Len: byte): string;
var i: integer;
    b: byte;
begin
  result:='';
  for i:=1 to Len do
  begin
    if not eof(Fic) then
    begin
      read(Fic, b);
    end else b:=0;
    result:=result+chr(b);
  end;
end;

function FReadAutoStr(var Fic: FileByte): string;
var i: integer;
    b: byte;
    Len: integer;
begin
  result:='';
  if not eof(Fic) then
  begin
    Len:=FReadInteger(Fic);
  end else Len:=0;

  if Len>0 then
    for i:=1 to Len do
    begin
      if not eof(Fic) then
      begin
        read(Fic, b);
      end else b:=0;
      result:=result+chr(b);
    end;
end;

procedure FWriteByte(var Fic: FileByte; Value: byte);
begin
  write(Fic, Value);
end;

procedure FWriteBool(var Fic: FileByte; Value: boolean);
var i: byte;
begin
  if value then i:=1 else i:=0;
  write(Fic, i);
end;

procedure FWriteInteger(var Fic: FileByte; Value: integer);
var c1, c2, c3, c4: byte;
    hex: string;
begin
  hex:=IntToHex(Value, 8);
  c1:=StrToInt('$'+hex[7]+hex[8]);
  c2:=StrToInt('$'+hex[5]+hex[6]);
  c3:=StrToInt('$'+hex[3]+hex[4]);
  c4:=StrToInt('$'+hex[1]+hex[2]);
  write(Fic, c1);
  write(Fic, c2);
  write(Fic, c3);
  write(Fic, c4);
end;

procedure FWriteStr(var Fic: FileByte; Value: string);
var i: integer;
    c: byte;
begin
  for i:=1 to length(Value) do
  begin
    c:=ord(Value[i]);
    write(Fic, c);
  end;
end;

procedure FWriteAutoStr(var Fic: FileByte; Value: string);
var i: integer;
    c: byte;
begin
  FWriteInteger(Fic, length(Value));
  for i:=1 to length(Value) do
  begin
    c:=ord(Value[i]);
    write(Fic, c);
  end;
end;

function GetVar(varname: string): string;
var buffer: array[0..1024] of char;
    size: integer;
begin
  size:=GetEnvironmentVariable(PChar(varname), buffer, sizeof(buffer));
  if size=0 then getvar:='' else getvar:=string(buffer);
end;

function GetParams: string;
var str, res: string;
    i, size: integer;
begin
  if GetVar('REQUEST_METHOD')='POST' then
  begin
    str:=GetVar('CONTENT_LENGTH');
    if str<>'' then
    begin
      size:=StrToInt(str);
      SetLength(res, size);
      for i:=1 to size do read(res[i]);
    end;
    result:=res;
  end else result:=getvar('QUERY_STRING');
  //result:=FormDecode(result);
end;

function GetParVal(params, par: string): string;
{var tamp: string;
begin
  if pos(uppercase(par), uppercase(params))>0 then
  begin
    tamp:=copy(params, pos(uppercase(par), uppercase(params))+length(par)+1, length(params)-pos(uppercase(par), uppercase(params))-length(par));
    if pos('&', tamp)>0 then
      tamp:=copy(tamp, 1, pos('&', tamp)-1);
    result:=tamp;
  end else result:='';
end;}
var i: integer;
begin
  result:='';
  sep:='&';
  for i:=1 to nbmots(params) do
  begin
    if pos(uppercase(par), uppercase(mot(i, params)))=1 then
    begin
      if pos('=', mot(i, params))>0 then result:=droite('=', mot(i, params));
    end;
  end;
  sep:=' ';
end;

function GetTextArea(params, par: string): TStringList;
var i: integer;
    Text, Tmp: string;
begin
  result:=TStringList.Create;
  Text:=remplace(FormDecode(GetParVal(params, par)), EOL, #13);
  {sep:=#13;
  for i:=1 to nbmots(Text) do
  begin
    result.Add(mot(i, Text));
  end;
  sep:=' ';}
  Tmp:='';
  for i:=1 to length(Text) do
  begin
    if Text[i]=#13 then
    begin
      result.Add(Tmp);
      Tmp:='';
    end else Tmp:=Tmp+Text[i];
  end;
  if Tmp<>'' then result.Add(Tmp);
end;

procedure Send(str: string);
begin
  writeln(str);
end;

procedure TextInit;
begin
  writeln('content-type: text/html');
  writeln;
end;

function FormDecode(str: string): string;
var i, n: integer;
    tamp, res: string;
    ch1, ch2: char;
begin
  tamp:=str;
  n:=0;
  res:='';
  for i:=1 to length(tamp) do
  begin
    if n=0 then
    begin
      if tamp[i]='+' then res:=res+' ' else
      if tamp[i]='%' then
      begin
        ch1:=tamp[i+1];
        ch2:=tamp[i+2];
        res:=res+chr(HexToInt(ch1+ch2));
        n:=2;
      end else res:=res+tamp[i];
    end else n:=n-1;
  end;
  result:=res;
end;

function ToHTML(str: string): string;
begin
  result:=remplace(str, chr($0D0A), '<BR>');
end;

function FormToHTML(str: string): string;
begin
  result:=FormDecode(remplace(str, '%0D%0A', '<BR>'));
end;

procedure delay(delai: double; var Appli: TApplication);
var HeureDepart: TDateTime;
begin
  HeureDepart:=now;
  delai:=delai/24/60/60/1000; //transforme les millisecondes en fractions de jours
  repeat
    Appli.ProcessMessages; // rend la main  Windows pour ne pas blocquer les autres applications
  until now>HeureDepart+Delai;
end;

function DaysIn(d: tdate): integer;
//var t, j, m, a: integer;
begin
{  Sep:='/';
  j:=StrToInt(mot(1, DateToStr(d)));
  m:=StrToInt(mot(2, DateToStr(d)));
  a:=StrToInt(mot(3, DateToStr(d)));
  sep:=' ';
  if a<90 then a:=2000+a else a:=1900+a;
  t:=j;
  // jours dans l'anne
  t:=t+trunc((a-1)*365.25);
  // jours dans les mois prcdents
  if m=2 then t:=t+31 else
  if m=3 then t:=t+31+28 else
  if m=4 then t:=t+31+28+31 else
  if m=5 then t:=t+31+28+31+30 else
  if m=6 then t:=t+31+28+31+30+31 else
  if m=7 then t:=t+31+28+31+30+31+30 else
  if m=8 then t:=t+31+28+31+30+31+30+31 else
  if m=9 then t:=t+31+28+31+30+31+30+31+31 else
  if m=10 then t:=t+31+28+31+30+31+30+31+31+30 else
  if m=11 then t:=t+31+28+31+30+31+30+31+31+30+31 else
  if m=12 then t:=t+31+28+31+30+31+30+31+31+30+31+30;
  if ((a div 4)=(a/4)) and (m>2) then t:=t+1;
  result:=t; }
  result:=trunc(d);
end;

function GetExeAll: string;
begin
  result:=ParamStr(0);
end;

function GetExePath: string;
var tamp: string;
begin
  tamp:=ParamStr(0);
  while pos('\', tamp)>0 do
  begin
    tamp:=copy(tamp, pos('\', tamp)+1, length(tamp)-pos('\', tamp));
  end;
  result:=remplace(ParamStr(0), tamp, '');
end;

function GetExeName: string;
var tamp: string;
begin
  tamp:=ParamStr(0);
  while pos('\', tamp)>0 do
  begin
    tamp:=copy(tamp, pos('\', tamp)+1, length(tamp)-pos('\', tamp));
  end;
  result:=tamp;
end;

function GetExeShortName: string;
var tamp: string;
begin
  tamp:=ParamStr(0);
  while pos('\', tamp)>0 do
  begin
    tamp:=copy(tamp, pos('\', tamp)+1, length(tamp)-pos('\', tamp));
  end;
  if pos('.', tamp)>0 then tamp:=copy(tamp, 1, pos('.', tamp)-1);
  result:=tamp;
end;

function DayOf(d: tdate): string;
var s: string;
begin
  s:=DateToStr(d);
  sep:='/';
  result:=mot(1, s);
  if length(result)=1 then result:='0'+result;
  sep:=' ';
end;

function MonthOf(d: tdate): string;
var s, r: string;
begin
  s:=DateToStr(d);
  sep:='/';
  r:=mot(2, s);
  sep:=' ';

  case strtoint(r) of
     1: result:='Janvier';
     2: result:='Fvrier';
     3: result:='Mars';
     4: result:='Avril';
     5: result:='Mai';
     6: result:='Juin';
     7: result:='Juillet';
     8: result:='Aot';
     9: result:='Septembre';
    10: result:='Octobre';
    11: result:='Novembre';
    12: result:='Dcembre';
  end;
end;

function MonthOfNum(num: integer): string;
begin
  case num of
     1: result:='Janvier';
     2: result:='Fvrier';
     3: result:='Mars';
     4: result:='Avril';
     5: result:='Mai';
     6: result:='Juin';
     7: result:='Juillet';
     8: result:='Aot';
     9: result:='Septembre';
    10: result:='Octobre';
    11: result:='Novembre';
    12: result:='Dcembre';
  end;
end;

function NumMonthOf(d: tdate): string;
var s, r: string;
begin
  s:=DateToStr(d);
  sep:='/';
  r:=mot(2, s);
  sep:=' ';
  if length(r)=1 then r:='0'+r;
  if length(r)>2 then r:=copy(r, 1, 2);
  result:=r;
end;

function YearOf(d: tdate): string;
var s: string;
begin
  s:=DateToStr(d);
  sep:='/';
  result:=mot(3, s);
  sep:=' ';
  if strtoint(result)<80 then result:='20'+result else result:='19'+result;
end;

function HourOf(t: TDateTime): string;
var s: string;
begin
  s:=TimeToStr(t);
  sep:=':';
  result:=mot(1, s);
  if length(result)=1 then result:='0'+result;
  if pos('PM', s)>0 then result:=IntToStr(StrToInt(result)+12);
  if length(result)>2 then result:=copy(result, 1, 2);
  sep:=' ';
end;

function MinOf(t: TDateTime): string;
var s: string;
begin
  s:=TimeToStr(t);
  sep:=':';
  result:=mot(2, s);
  if length(result)=1 then result:='0'+result;
  if length(result)>2 then result:=copy(result, 1, 2);
  sep:=' ';
end;

function SecOf(t: TDateTime): string;
var s: string;
begin
  s:=TimeToStr(t);
  sep:=':';
  result:=mot(3, s);
  if length(result)=1 then result:='0'+result;
  if length(result)>2 then result:=copy(result, 1, 2);
  sep:=' ';
end;

function WMatch(wild, all: string): boolean; // WildCard Match
var w, a: integer;
    ok: boolean;
begin
  // Ne marche pas pour aa*a dans aaaaaaaaa par exemple, parce qu'il veut aa*aaaaaa
  result:=false;
  wild:=remplace(wild, '**', '*');
  if (wild<>'') or (all<>'') then
  begin
    w:=1;
    a:=1;
    ok:=true;
    while ok do
    begin
      if wild[w]<>'*' then
      begin
        ok:=wild[w]=all[a];
        inc(w);
      end else begin
        if (w<>length(wild)) and (a<>length(all)) then
        begin
          if (wild[w+1]=all[a+1]) {or (wild[w+1]=all[a])} then inc(w);
        end else if (a=length(all)) and (w=length(wild)) then inc(w);
      end;
      inc(a);
      if a=length(all)+1 then
      begin
        if ok then result:=((w=length(wild)+1) and (a=length(all)+1))
              else result:=false;
        ok:=false;
      end;
    end;
  end else result:=(wild=all) or (wild='*');
end;

function Puissance(Nb, P: integer): integer;
var i: integer;
begin
  result:=Nb;
  if P>0 then
  begin
    for i:=2 to P do
      result:=result*Nb;
  end;
  if P=0 then result:=1;
end;

function Rounded(N: real; R: integer): integer;
begin
  result:=round(N/R)*R;
end;

procedure Debug(Txt: array of const);
const
  BoolChars: array[Boolean] of Char = ('F', 'T');
var
  I: Integer;
  S, FN: string;
  Fic: TextFile;
begin
  S := '';
  for I := 0 to High(Txt) do
    with Txt[I] do
      case VType of
        vtInteger:    S := S + IntToStr(VInteger);
        vtBoolean:    S := S + BoolChars[VBoolean];
        vtChar:       S := S + VChar;
        vtExtended:   S := S + FloatToStr(VExtended^);
        vtString:     S := S + VString^;
        vtPChar:      S := S + VPChar;

        vtObject:     S := S + VObject.ClassName;
        vtClass:      S := S + VClass.ClassName;
        vtAnsiString: S := S + string(VAnsiString);
        vtCurrency:   S := S + CurrToStr(VCurrency^);
        vtVariant:    S := S + string(VVariant^);
        vtInt64:      S := S + IntToStr(VInt64^);
    end;

  FN:=GetExeName;
  if pos('.', FN)>0 then FN:=copy(FN, 1, pos('.', FN)-1);
  FN:=lowercase(FN)+'_log.txt';

  AssignFile(Fic, FN);
  if fileexists(FN) then Append(Fic) else Rewrite(Fic);
  writeln(Fic, S);
  CloseFile(Fic);
end;

procedure ClearDebug;
var FN: string;
begin
  FN:=GetExeName;
  if pos('.', FN)>0 then FN:=copy(FN, 1, pos('.', FN)-1);
  FN:=lowercase(FN)+'_log.txt';
  if FileExists(FN) then DeleteFile(FN);
end;

procedure DebugBeginTC;
begin
  BeginTimeCountVar:=GetTickCount;
end;

procedure DebugEndTC;
begin
  EndTimeCountVar:=GetTickCount;
end;

function DebugTC: cardinal;
begin
  result:=EndTimeCountVar-BeginTimeCountVar;
  DebugBeginTC;
end;

function B4ToInt(B1, B2, B3, B4: byte): integer;
begin
  result:=StrToInt('$'+IntToHex(b4, 2)+IntToHex(b3, 2)+IntToHex(b2, 2)+IntToHex(b1, 2));
end;

function IntToB1(int: integer): byte;
var hex: string;
begin
  hex:=IntToHex(int, 8);
  result:=StrToInt('$'+hex[7]+hex[8]);
end;

function IntToB2(int: integer): byte;
var hex: string;
begin
  hex:=IntToHex(int, 8);
  result:=StrToInt('$'+hex[5]+hex[6]);
end;

function IntToB3(int: integer): byte;
var hex: string;
begin
  hex:=IntToHex(int, 8);
  result:=StrToInt('$'+hex[3]+hex[4]);
end;

function IntToB4(int: integer): byte;
var hex: string;
begin
  hex:=IntToHex(int, 8);
  result:=StrToInt('$'+hex[1]+hex[2]);
end;

function GetDay(When: TDateTime): string;
begin
  result:=FormatDateTime('dd', When);
end;

function GetMonth(When: TDateTime): string;
begin
  result:=FormatDateTime('mm', When);
end;

function GetYear(When: TDateTime): string;
begin
  result:=FormatDateTime('yy', When);
end;

function GetAllHour(When: TDateTime): string;
begin
  result:=inttostr(trunc(When*24));
end;

function GetHour(When: TDateTime): string;
begin
  result:=FormatDateTime('hh', When);
end;

function GetMin(When: TDateTime): string;
begin
  result:=FormatDateTime('nn', When);
end;

function GetSec(When: TDateTime): string;
begin
  result:=FormatDateTime('ss', When);
end;

function GetNDay(When: TDateTime): integer;
begin
  result:=strtoint(FormatDateTime('dd', When));
end;

function GetNMonth(When: TDateTime): integer;
begin
  result:=strtoint(FormatDateTime('mm', When));
end;

function GetNYear(When: TDateTime): integer;
begin
  result:=strtoint(FormatDateTime('yy', When));
end;

function GetNHour(When: TDateTime): integer;
begin
  result:=strtoint(FormatDateTime('hh', When));
end;

function GetNMin(When: TDateTime): integer;
begin
  result:=strtoint(FormatDateTime('nn', When));
end;

function GetNSec(When: TDateTime): integer;
begin
  result:=strtoint(FormatDateTime('ss', When));
end;

function AddTime(When: TDateTime; Hour, Min, Sec: integer): TDateTime;
begin
  result:=When + Hour/24 + Min/24/60 + Sec/24/60/60;
end;

function AddTime(When: TDateTime; Hour: integer): TDateTime;
begin
  result:=When + Hour/24;
end;

function AddDays(When: TDateTime; Days: integer): TDateTime;
begin
  result:=When+Days;
end;

function BTSTF(b: boolean): string;
begin
  if b then result:='True' else result:='False';
end;

function StrLSized(s: string; size: integer; AddCharToLeft: char): string;
begin
  result:=s;
  while length(result)<size do result:=AddCharToLeft+result;
end;

function StrRSized(s: string; size: integer; AddCharToRight: char): string;
begin
  result:=s;
  while length(result)<size do result:=result+AddCharToRight;
end;

function IntToFileSize(i: integer): string;
begin
  if i<1024 then
  begin
    result:=inttostr(i)+' oc.';
  end else
  if i<1024*1024 then
  begin
    result:=copy(floattostr(i/(1024)), 1, 4)+' Ko';
  end else
  if i<1024*1024*1024 then
  begin
    result:=copy(floattostr(i/(1024*1024)), 1, 4)+' Mo';
  end else
  begin
    result:=copy(floattostr(i/(1024*1024*1024)), 1, 4)+' Go';
  end;
end;

function WinDir: string;
var s: PChar;
begin
  s:='c:\windows'#0'                                                  ';
  GetWindowsDirectory(s, 50);
  result:=s;
  if result='' then result:='\' else
  begin
    if result[length(result)]<>'\' then result:=result+'\';
  end;
end;

function ExpPars(s: string; gui, spc: char): TStringList;
var oldsep: char;
begin
  result:=TStringList.Create;
  oldsep:=sep;
  sep:=spc;
  s:=min(s);
  while s<>'' do
  begin
    if s[1]=gui then
    begin
      s:=copy(s, 2, length(s)-1);
      result.add(copy(s, 1, pos(gui, s)-1));
      s:=min(copy(s, pos(gui, s)+1, length(s)-pos(gui, s)));
    end else begin
      result.add(mot(1, s));
      if pos(spc, s)>0 then s:=min(droite(spc, s)) else s:='';
    end;
  end;
  sep:=oldsep;
end;

function ExpPars(s: string): TStringList;
begin
  result:=ExpPars(s, '"', ' ');
end;

function booltostr(b: boolean; t, f: string): string;
begin
  if b then result:=t else result:=f;
end;

function booltostr(b: boolean): string;
begin
  result:=booltostr(b, 'true', 'false');
end;

function strtobool(s: string; t, f: string): boolean; overload;
begin
  result:=lowercase(min(s))=lowercase(min(t));
end;

function strtobool(s: string): boolean; overload;
begin
  s:=lowercase(min(s));
  result:=(s='true') or (s='yes') or (s='1') or (s='oui') or (s='y') or (s='o');
end;

function bit(bitnum, int: cardinal): boolean;
begin
  result:=(int and (1 shl (bitnum - 1)))>0;
end;

{ TExtFileStream }

function TExtFileStream.ReadBool: boolean;
begin
  Read(result, 1);
end;

function TExtFileStream.ReadByte: byte;
begin
  Read(result, 1);
end;

function TExtFileStream.ReadChar: char;
begin
  Read(result, 1);
end;

function TExtFileStream.ReadInteger: integer;
begin
  Read(result, 4);
end;

function TExtFileStream.ReadStr: string;
var cnt: integer;
    c: char;
    i: integer;
begin
  result:='';
  Read(cnt, 4);
  for i:=1 to cnt do
  begin
    Read(c, 1);
    result:=result+c;
  end;
end;

procedure TExtFileStream.WriteBool(bool: boolean);
begin
  Write(bool, 1);
end;

procedure TExtFileStream.WriteByte(by: byte);
begin
  Write(by, 1);
end;

procedure TExtFileStream.WriteCardinal(int: cardinal);
begin
  Write(int, 4);
end;

procedure TExtFileStream.WriteChar(ch: char);
begin
  Write(ch, 1);
end;

procedure TExtFileStream.WriteInteger(int: integer);
begin
  Write(int, 4);
end;

procedure TExtFileStream.WriteStr(str: string);
var i: integer;
begin
  WriteInteger(length(str));
  for i:=1 to length(str) do Write(str[i], 1);
end;

procedure TExtFileStream.WriteStrWOSize(str: string);
var i: integer;
begin
  for i:=1 to length(str) do Write(str[i], 1);
end;

{ TExtMemoryStream }

function TExtMemoryStream.ReadBool: boolean;
begin
  Read(result, 1);
end;

procedure TExtMemoryStream.ReadBool(var bool: boolean);
begin
  Read(bool, 1);
end;

function TExtMemoryStream.ReadByte: byte;
begin
  Read(result, 1);
end;

procedure TExtMemoryStream.ReadByte(var by: byte);
begin
  Read(by, 1);
end;

procedure TExtMemoryStream.ReadCardinal(var int: cardinal);
begin
  Read(int, 4);
end;

function TExtMemoryStream.ReadCardinal: cardinal;
begin
  Read(result, 4);
end;

function TExtMemoryStream.ReadChar: char;
begin
  Read(result, 1);
end;

procedure TExtMemoryStream.ReadChar(var ch: char);
begin
  Read(ch, 1);
end;

function TExtMemoryStream.ReadDouble: double;
begin
  Read(result, 8);
end;

procedure TExtMemoryStream.ReadDouble(var d: double);
begin
  Read(d, 8);
end;

function TExtMemoryStream.ReadInteger: integer;
begin
  Read(result, 4);
end;

procedure TExtMemoryStream.ReadInteger(var int: integer);
begin
  Read(int, 4);
end;

function TExtMemoryStream.ReadStr: string;
var cnt: integer;
    c: char;
    i: integer;
begin
  result:='';
  Read(cnt, 4);
  for i:=1 to cnt do
  begin
    Read(c, 1);
    result:=result+c;
  end;
end;

procedure TExtMemoryStream.ReadStr(var str: string);
begin
  str:=ReadStr;
end;

procedure TExtMemoryStream.ReadStrWOSize(var str: string; Size: integer);
var c: char;
    i: integer;
begin
  str:='';
  for i:=1 to size do
  begin
    Read(c, 1);
    str:=str+c;
  end;
end;

function TExtMemoryStream.ReadStrWOSize(Size: integer): string;
var c: char;
    i: integer;
begin
  result := '';
  for i := 1 to Size do
  begin
    Read(c, 1);
    result := result + c;
  end;
end;

procedure TExtMemoryStream.ReadWord(var int: word);
begin
  Read(int, 2);
end;

procedure TExtMemoryStream.WriteBool(bool: boolean);
begin
  Write(bool, 1);
end;

procedure TExtMemoryStream.WriteByte(by: byte);
begin
  Write(by, 1);
end;

procedure TExtMemoryStream.WriteCardinal(int: cardinal);
begin
  Write(int, 4);
end;

procedure TExtMemoryStream.WriteChar(ch: char);
begin
  Write(ch, 1);
end;

procedure TExtMemoryStream.WriteDouble(d: double);
begin
  Write(d, 8);
end;

procedure TExtMemoryStream.WriteInteger(int: integer);
begin
  Write(int, 4);
end;

procedure TExtMemoryStream.WriteStr(str: string);
var i: integer;
begin
  WriteInteger(length(str));
  for i:=1 to length(str) do Write(str[i], 1);
end;

procedure TExtMemoryStream.WriteStrWOSize(str: string);
var i: integer;
begin
  for i:=1 to length(str) do Write(str[i], 1);
end;

procedure TExtMemoryStream.WriteWord(int: word);
begin
  Write(int, 2);
end;

{ Fin des ExtStream }

function ExtPos(sub, s: string; n: integer): integer;
var i, t: integer;
begin
  result:=0;
  t:=0;
  for i:=1 to n-1 do
  begin
    t:=t+pos(sub, s)+length(sub)-1;
    s:=droite(sub, s);
  end;
  if pos(sub, s)>0 then
  begin
    result:=t+pos(sub, s);
  end;
end;

function ExtDroite(sub, s: string; n: integer): string;
begin
  result:=copy(s, extpos(sub, s, n)+length(sub), length(s)-extpos(sub, s, n)+length(sub));
end;

function ExtGauche(sub, s: string; n: integer): string;
begin
  result:=copy(s, 1, extpos(sub, s, n)-1);
end;

function SubCount(sub, s: string): integer;
begin
  result:=0;
  while pos(sub, s)>0 do
  begin
    inc(result);
    s:=droite(sub, s);
  end;
end;

procedure MakeDir(dir: string);
var vol, path, s: string;
    i: integer;
begin
  if pos(':', dir)>0 then
  begin
    vol:=copy(dir, 1, 2);
    path:=droite(':', dir)+'\';
  end else begin
    vol:='';
    path:=dir+'\';
  end;
  sep:='\';
  for i:=1 to nbmots(path) do
  begin
    s:=ExtGauche('\', path, i);
    if s<>'' then s:=vol+s;
    if s<>'' then CreateDirectory(PChar(s), nil);
  end;
  CreateDirectory(PChar(dir), nil);
  sep:=' ';
end;

function PointInRect(X, Y: integer; XR, YR, W, H: integer): boolean;
begin
  W:=W div 2;
  H:=H div 2;
  result:=(X>XR-W) and (Y>YR-H) and (X<XR+W) and (Y<YR+H);
end;

procedure TExtFileStream.WriteWord(int: word);
begin
  write(int, 2);
end;

function IntPower(Base: Extended; Exponent: Integer): Extended;
asm
  // Copied from Math unit
        mov     ecx, eax
        cdq
        fld1                      { Result := 1 }
        xor     eax, edx
        sub     eax, edx          { eax := Abs(Exponent) }
        jz      @@3
        fld     Base
        jmp     @@2
@@1:    fmul    ST, ST            { X := Base * Base }
@@2:    shr     eax,1
        jnc     @@1
        fmul    ST(1),ST          { Result := Result * X }
        jnz     @@1
        fstp    st                { pop X from FPU stack }
        cmp     ecx, 0
        jge     @@3
        fld1
        fdivrp                    { Result := 1 / Result }
@@3:
        fwait
end;

function Power(Base, Exponent: Extended): Extended;
begin
  // Copied from Math unit
  if Exponent = 0.0 then
    Result := 1.0               { n**0 = 1 }
  else if (Base = 0.0) and (Exponent > 0.0) then
    Result := 0.0               { 0**n = 0, n > 0 }
  else if (Frac(Exponent) = 0.0) and (Abs(Exponent) <= MaxInt) then
    Result := IntPower(Base, Integer(Trunc(Exponent)))
  else
    Result := Exp(Exponent * Ln(Base))
end;

function StrIsInt(S: string): boolean;
{var i: integer;
    n: byte;
    h: boolean; }
begin
{  result:=true;
  if S<>'' then
  begin
    // hexa?
    if S[1]='$' then
    begin
      S:=copy(S, 2, length(S)-1);
      h:=true;
    end else h:=false;
    // test 1o par 1o
    for i:=1 to length(S) do
    begin
      n:=ord(S[i]);
      if h then
      begin
        if not (((n>=48) and (n<=57)) or // 0..9
                ((n>=65) and (n<=70)) or // A..F
                ((n>=97) and (n<=102))) then result:=false; // a..f
      end else
      begin
        if (n<48) or (n>57) then result:=false; // 0..9
      end;
    end;
  end else result:=false; }

  result:=(StrToIntDef(S, 0)<>0) or (StrToIntDef(S, 1)<>1);
end;

procedure FileSearch(path, filter: string; Folders: boolean; SubFolders: integer; AddTo: TStringList; AddIfExists: boolean);
var Resultat: integer;
    DirInfo: TSearchRec;
    S: string;
begin
  path:=StrEndedC(path, '\');

  Resultat:=FindFirst(path+filter, FaDirectory+FaAnyFile+faHidden+faSysFile+faReadOnly, DirInfo);
  while (Resultat=0) do
  begin
    if (FaDirectory and DirInfo.Attr) = 0 then
    begin
      if (AddTo.IndexOf(Path+DirInfo.Name)<0) or AddIfExists then AddTo.Add(Path+DirInfo.Name);
    end else begin
      if (DirInfo.Name<>'.') and (DirInfo.Name<>'..') then
      begin
        S:=StrEndedC(Path+DirInfo.Name, '\');
        if Folders then if (AddTo.IndexOf(S)<0) or AddIfExists then AddTo.Add(S);
        if SubFolders>0 then FileSearch(S, filter, Folders, SubFolders-1, AddTo, AddIfExists);
        if SubFolders=-1 then FileSearch(S, filter, Folders, -1, AddTo, AddIfExists);
      end;
    end;
    Resultat:=FindNext(DirInfo);
  end;

  {if Folders or (SubFolders>0) or (SubFolders=-1) then
  begin
    Resultat:=FindFirst(path+filter, FaDirectory+faHidden+faSysFile+faReadOnly, DirInfo);
    while (Resultat=0) Do
    begin
      if (DirInfo.Name<>'.') and (DirInfo.Name<>'..') and ((FaDirectory and DirInfo.Attr) <> 0) then
      begin
        S:=StrEnded(Path+DirInfo.Name, '\');
        if Folders then if (AddTo.IndexOf(S)<0) or AddIfExists then AddTo.Add(S);
        if SubFolders>0 then FileSearch(S, filter, Folders, SubFolders-1, AddTo, AddIfExists);
        if SubFolders=-1 then FileSearch(S, filter, Folders, -1, AddTo, AddIfExists);
      end;
      Resultat:=FindNext(DirInfo);
    end;
  end;}
end;

function FileSearch(path, filter: string; Folders: boolean; SubFolders: integer): TStringList;
begin
  result:=TStringList.Create;
  FileSearch(path, filter, Folders, SubFolders, result, false);
end;

function StrEnded(str, e: string): string;
begin
  if extpos(e, str, subcount(e, str))<>length(str)-length(e)+1 then result:=str+e else result:=str;
end;

function StrEndedC(str: string; e: char): string;
begin
  result:=str;
  if str='' then exit;
  if str[length(str)]<>e then result:=str+e;
end;

function RegExtractAssociatedIcon(Ext: string; small: boolean): HICON;
var Reg: TRegistry;
    i: integer;
    IconFile, S: string;
    IconIndex, nIcons: integer;
    IconHandleL, IconHandleS: HICON;
begin
  Reg:=TRegistry.Create;
  Reg.RootKey:=HKEY_CLASSES_ROOT;
  if pos('.', Ext)<>1 then Ext:='.'+Ext;
  if Reg.OpenKey('\'+Ext, false) then
  begin
    if Reg.OpenKey('\'+Reg.ReadString(''), false) then
      if Reg.OpenKey('DefaultIcon', false) then
      begin
        S:=Reg.ReadString('');
        if pos(',', S)>0 then
        begin
          IconFile:=ExtGauche(',', S, subcount(',', S));
          IconIndex:=StrToIntDef(ExtDroite(',', S, subcount(',', S)), 0);
        end else begin
          IconFile:=S;
          IconIndex:=0;
        end;
        if FileExists(IconFile) then
        begin
          IconHandleL:=0;
          nIcons:=ExtractIconEx(PChar(IconFile), IconIndex, IconHandleL, IconHandleS, 1);
          if nIcons>0 then
            if small then result:=IconHandleS else result:=IconHandleL;
        end;
      end;
  end;
  Reg.Free;
end;

function MyGetTickCount: cardinal;
var lpPerformanceCount, lpFrequency: TLargeInteger;
begin
  if not QueryPerformanceCounter(lpPerformanceCount) then lpPerformanceCount:=GetTickCount else
  begin
    QueryPerformanceFrequency(lpFrequency);
    lpPerformanceCount:=(lpPerformanceCount*1000) div lpFrequency
  end;
  result:=lpPerformanceCount;
end;

end.
